# coding: utf-8

"""
    Clerk Backend API

    The Clerk REST Backend API, meant to be accessed by backend servers.  ### Versions  When the API changes in a way that isn't compatible with older versions, a new version is released. Each version is identified by its release date, e.g. `2021-02-05`. For more information, please see [Clerk API Versions](https://clerk.com/docs/backend-requests/versioning/overview).   Please see https://clerk.com/docs for more information.

    The version of the OpenAPI document: v1
    Contact: support@clerk.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, Optional
from typing import Optional, Set
from typing_extensions import Self

class AllowlistIdentifier(BaseModel):
    """
    AllowlistIdentifier
    """ # noqa: E501
    object: Optional[StrictStr] = Field(default=None, description="String representing the object's type. Objects of the same type share the same value. ")
    id: Optional[StrictStr] = None
    invitation_id: Optional[StrictStr] = None
    identifier: Optional[StrictStr] = Field(default=None, description="An email address or a phone number. ")
    identifier_type: Optional[StrictStr] = None
    instance_id: Optional[StrictStr] = None
    created_at: Optional[StrictInt] = Field(default=None, description="Unix timestamp of creation ")
    updated_at: Optional[StrictInt] = Field(default=None, description="Unix timestamp of last update. ")
    __properties: ClassVar[List[str]] = ["object", "id", "invitation_id", "identifier", "identifier_type", "instance_id", "created_at", "updated_at"]

    @field_validator('object')
    def object_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['allowlist_identifier']):
            raise ValueError("must be one of enum values ('allowlist_identifier')")
        return value

    @field_validator('identifier_type')
    def identifier_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['email_address', 'phone_number', 'web3_wallet']):
            raise ValueError("must be one of enum values ('email_address', 'phone_number', 'web3_wallet')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AllowlistIdentifier from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AllowlistIdentifier from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "object": obj.get("object"),
            "id": obj.get("id"),
            "invitation_id": obj.get("invitation_id"),
            "identifier": obj.get("identifier"),
            "identifier_type": obj.get("identifier_type"),
            "instance_id": obj.get("instance_id"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at")
        })
        return _obj


