# coding: utf-8

"""
    Clerk Backend API

    The Clerk REST Backend API, meant to be accessed by backend servers.  ### Versions  When the API changes in a way that isn't compatible with older versions, a new version is released. Each version is identified by its release date, e.g. `2021-02-05`. For more information, please see [Clerk API Versions](https://clerk.com/docs/backend-requests/versioning/overview).   Please see https://clerk.com/docs for more information.

    The version of the OpenAPI document: v1
    Contact: support@clerk.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from clerk_backend_sdk.models.session import Session
from typing import Optional, Set
from typing_extensions import Self

class Client(BaseModel):
    """
    Client
    """ # noqa: E501
    object: StrictStr = Field(description="String representing the object's type. Objects of the same type share the same value. ")
    id: StrictStr = Field(description="String representing the identifier of the session. ")
    session_ids: List[StrictStr]
    sessions: List[Session]
    sign_in_id: Optional[StrictStr]
    sign_up_id: Optional[StrictStr]
    last_active_session_id: Optional[StrictStr] = Field(description="Last active session_id. ")
    updated_at: StrictInt = Field(description="Unix timestamp of last update. ")
    created_at: StrictInt = Field(description="Unix timestamp of creation. ")
    __properties: ClassVar[List[str]] = ["object", "id", "session_ids", "sessions", "sign_in_id", "sign_up_id", "last_active_session_id", "updated_at", "created_at"]

    @field_validator('object')
    def object_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['client']):
            raise ValueError("must be one of enum values ('client')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Client from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in sessions (list)
        _items = []
        if self.sessions:
            for _item_sessions in self.sessions:
                if _item_sessions:
                    _items.append(_item_sessions.to_dict())
            _dict['sessions'] = _items
        # set to None if sign_in_id (nullable) is None
        # and model_fields_set contains the field
        if self.sign_in_id is None and "sign_in_id" in self.model_fields_set:
            _dict['sign_in_id'] = None

        # set to None if sign_up_id (nullable) is None
        # and model_fields_set contains the field
        if self.sign_up_id is None and "sign_up_id" in self.model_fields_set:
            _dict['sign_up_id'] = None

        # set to None if last_active_session_id (nullable) is None
        # and model_fields_set contains the field
        if self.last_active_session_id is None and "last_active_session_id" in self.model_fields_set:
            _dict['last_active_session_id'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Client from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "object": obj.get("object"),
            "id": obj.get("id"),
            "session_ids": obj.get("session_ids"),
            "sessions": [Session.from_dict(_item) for _item in obj["sessions"]] if obj.get("sessions") is not None else None,
            "sign_in_id": obj.get("sign_in_id"),
            "sign_up_id": obj.get("sign_up_id"),
            "last_active_session_id": obj.get("last_active_session_id"),
            "updated_at": obj.get("updated_at"),
            "created_at": obj.get("created_at")
        })
        return _obj


