# coding: utf-8

"""
    Clerk Backend API

    The Clerk REST Backend API, meant to be accessed by backend servers.  ### Versions  When the API changes in a way that isn't compatible with older versions, a new version is released. Each version is identified by its release date, e.g. `2021-02-05`. For more information, please see [Clerk API Versions](https://clerk.com/docs/backend-requests/versioning/overview).   Please see https://clerk.com/docs for more information.

    The version of the OpenAPI document: v1
    Contact: support@clerk.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class CreateJWTTemplateRequest(BaseModel):
    """
    CreateJWTTemplateRequest
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="JWT template name")
    claims: Optional[Dict[str, Any]] = Field(default=None, description="JWT template claims in JSON format")
    lifetime: Optional[Union[Annotated[float, Field(le=315360000, strict=True, ge=30)], Annotated[int, Field(le=315360000, strict=True, ge=30)]]] = Field(default=None, description="JWT token lifetime")
    allowed_clock_skew: Optional[Union[Annotated[float, Field(le=300, strict=True, ge=0)], Annotated[int, Field(le=300, strict=True, ge=0)]]] = Field(default=None, description="JWT token allowed clock skew")
    custom_signing_key: Optional[StrictBool] = Field(default=None, description="Whether a custom signing key/algorithm is also provided for this template")
    signing_algorithm: Optional[StrictStr] = Field(default=None, description="The custom signing algorithm to use when minting JWTs")
    signing_key: Optional[StrictStr] = Field(default=None, description="The custom signing private key to use when minting JWTs")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["name", "claims", "lifetime", "allowed_clock_skew", "custom_signing_key", "signing_algorithm", "signing_key"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateJWTTemplateRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        # set to None if lifetime (nullable) is None
        # and model_fields_set contains the field
        if self.lifetime is None and "lifetime" in self.model_fields_set:
            _dict['lifetime'] = None

        # set to None if allowed_clock_skew (nullable) is None
        # and model_fields_set contains the field
        if self.allowed_clock_skew is None and "allowed_clock_skew" in self.model_fields_set:
            _dict['allowed_clock_skew'] = None

        # set to None if signing_algorithm (nullable) is None
        # and model_fields_set contains the field
        if self.signing_algorithm is None and "signing_algorithm" in self.model_fields_set:
            _dict['signing_algorithm'] = None

        # set to None if signing_key (nullable) is None
        # and model_fields_set contains the field
        if self.signing_key is None and "signing_key" in self.model_fields_set:
            _dict['signing_key'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateJWTTemplateRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "claims": obj.get("claims"),
            "lifetime": obj.get("lifetime"),
            "allowed_clock_skew": obj.get("allowed_clock_skew"),
            "custom_signing_key": obj.get("custom_signing_key"),
            "signing_algorithm": obj.get("signing_algorithm"),
            "signing_key": obj.get("signing_key")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


