# coding: utf-8

"""
    Clerk Backend API

    The Clerk REST Backend API, meant to be accessed by backend servers.  ### Versions  When the API changes in a way that isn't compatible with older versions, a new version is released. Each version is identified by its release date, e.g. `2021-02-05`. For more information, please see [Clerk API Versions](https://clerk.com/docs/backend-requests/versioning/overview).   Please see https://clerk.com/docs for more information.

    The version of the OpenAPI document: v1
    Contact: support@clerk.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from clerk_backend_sdk.models.admin import Admin
from clerk_backend_sdk.models.oauth import Oauth
from clerk_backend_sdk.models.otp import OTP
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

EMAILADDRESSVERIFICATION_ONE_OF_SCHEMAS = ["Admin", "OTP", "Oauth"]

class EmailAddressVerification(BaseModel):
    """
    EmailAddressVerification
    """
    # data type: OTP
    oneof_schema_1_validator: Optional[OTP] = None
    # data type: Admin
    oneof_schema_2_validator: Optional[Admin] = None
    # data type: Oauth
    oneof_schema_3_validator: Optional[Oauth] = None
    actual_instance: Optional[Union[Admin, OTP, Oauth]] = None
    one_of_schemas: Set[str] = { "Admin", "OTP", "Oauth" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        if v is None:
            return v

        instance = EmailAddressVerification.model_construct()
        error_messages = []
        match = 0
        # validate data type: OTP
        if not isinstance(v, OTP):
            error_messages.append(f"Error! Input type `{type(v)}` is not `OTP`")
        else:
            match += 1
        # validate data type: Admin
        if not isinstance(v, Admin):
            error_messages.append(f"Error! Input type `{type(v)}` is not `Admin`")
        else:
            match += 1
        # validate data type: Oauth
        if not isinstance(v, Oauth):
            error_messages.append(f"Error! Input type `{type(v)}` is not `Oauth`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in EmailAddressVerification with oneOf schemas: Admin, OTP, Oauth. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in EmailAddressVerification with oneOf schemas: Admin, OTP, Oauth. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: Optional[str]) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        if json_str is None:
            return instance

        error_messages = []
        match = 0

        # deserialize data into OTP
        try:
            instance.actual_instance = OTP.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into Admin
        try:
            instance.actual_instance = Admin.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into Oauth
        try:
            instance.actual_instance = Oauth.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into EmailAddressVerification with oneOf schemas: Admin, OTP, Oauth. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into EmailAddressVerification with oneOf schemas: Admin, OTP, Oauth. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], Admin, OTP, Oauth]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


