# coding: utf-8

"""
    Clerk Backend API

    The Clerk REST Backend API, meant to be accessed by backend servers.  ### Versions  When the API changes in a way that isn't compatible with older versions, a new version is released. Each version is identified by its release date, e.g. `2021-02-05`. For more information, please see [Clerk API Versions](https://clerk.com/docs/backend-requests/versioning/overview).   Please see https://clerk.com/docs for more information.

    The version of the OpenAPI document: v1
    Contact: support@clerk.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GetOAuthAccessToken200ResponseInner(BaseModel):
    """
    GetOAuthAccessToken200ResponseInner
    """ # noqa: E501
    object: Optional[StrictStr] = None
    external_account_id: Optional[StrictStr] = Field(default=None, description="External account ID")
    provider_user_id: Optional[StrictStr] = Field(default=None, description="The unique ID of the user in the external provider's system")
    token: Optional[StrictStr] = Field(default=None, description="The access token")
    provider: Optional[StrictStr] = Field(default=None, description="The ID of the provider")
    public_metadata: Optional[Dict[str, Any]] = None
    label: Optional[StrictStr] = None
    scopes: Optional[List[StrictStr]] = Field(default=None, description="The list of scopes that the token is valid for. Only present for OAuth 2.0 tokens.")
    token_secret: Optional[StrictStr] = Field(default=None, description="The token secret. Only present for OAuth 1.0 tokens.")
    __properties: ClassVar[List[str]] = ["object", "external_account_id", "provider_user_id", "token", "provider", "public_metadata", "label", "scopes", "token_secret"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetOAuthAccessToken200ResponseInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if label (nullable) is None
        # and model_fields_set contains the field
        if self.label is None and "label" in self.model_fields_set:
            _dict['label'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetOAuthAccessToken200ResponseInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "object": obj.get("object"),
            "external_account_id": obj.get("external_account_id"),
            "provider_user_id": obj.get("provider_user_id"),
            "token": obj.get("token"),
            "provider": obj.get("provider"),
            "public_metadata": obj.get("public_metadata"),
            "label": obj.get("label"),
            "scopes": obj.get("scopes"),
            "token_secret": obj.get("token_secret")
        })
        return _obj


