# coding: utf-8

"""
    Clerk Backend API

    The Clerk REST Backend API, meant to be accessed by backend servers.  ### Versions  When the API changes in a way that isn't compatible with older versions, a new version is released. Each version is identified by its release date, e.g. `2021-02-05`. For more information, please see [Clerk API Versions](https://clerk.com/docs/backend-requests/versioning/overview).   Please see https://clerk.com/docs for more information.

    The version of the OpenAPI document: v1
    Contact: support@clerk.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, Optional
from typing import Optional, Set
from typing_extensions import Self

class Session(BaseModel):
    """
    Session
    """ # noqa: E501
    object: StrictStr = Field(description="String representing the object's type. Objects of the same type share the same value. ")
    id: StrictStr
    user_id: StrictStr
    client_id: StrictStr
    actor: Optional[Dict[str, Any]] = None
    status: StrictStr
    last_active_organization_id: Optional[StrictStr] = None
    last_active_at: StrictInt
    expire_at: StrictInt
    abandon_at: StrictInt
    updated_at: StrictInt = Field(description="Unix timestamp of last update. ")
    created_at: StrictInt = Field(description="Unix timestamp of creation. ")
    __properties: ClassVar[List[str]] = ["object", "id", "user_id", "client_id", "actor", "status", "last_active_organization_id", "last_active_at", "expire_at", "abandon_at", "updated_at", "created_at"]

    @field_validator('object')
    def object_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['session']):
            raise ValueError("must be one of enum values ('session')")
        return value

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['active', 'revoked', 'ended', 'expired', 'removed', 'abandoned', 'replaced']):
            raise ValueError("must be one of enum values ('active', 'revoked', 'ended', 'expired', 'removed', 'abandoned', 'replaced')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Session from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if actor (nullable) is None
        # and model_fields_set contains the field
        if self.actor is None and "actor" in self.model_fields_set:
            _dict['actor'] = None

        # set to None if last_active_organization_id (nullable) is None
        # and model_fields_set contains the field
        if self.last_active_organization_id is None and "last_active_organization_id" in self.model_fields_set:
            _dict['last_active_organization_id'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Session from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "object": obj.get("object"),
            "id": obj.get("id"),
            "user_id": obj.get("user_id"),
            "client_id": obj.get("client_id"),
            "actor": obj.get("actor"),
            "status": obj.get("status"),
            "last_active_organization_id": obj.get("last_active_organization_id"),
            "last_active_at": obj.get("last_active_at"),
            "expire_at": obj.get("expire_at"),
            "abandon_at": obj.get("abandon_at"),
            "updated_at": obj.get("updated_at"),
            "created_at": obj.get("created_at")
        })
        return _obj


