# coding: utf-8

"""
    Clerk Backend API

    The Clerk REST Backend API, meant to be accessed by backend servers.  ### Versions  When the API changes in a way that isn't compatible with older versions, a new version is released. Each version is identified by its release date, e.g. `2021-02-05`. For more information, please see [Clerk API Versions](https://clerk.com/docs/backend-requests/versioning/overview).   Please see https://clerk.com/docs for more information.

    The version of the OpenAPI document: v1
    Contact: support@clerk.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class UpdateInstanceOrganizationSettingsRequest(BaseModel):
    """
    UpdateInstanceOrganizationSettingsRequest
    """ # noqa: E501
    enabled: Optional[StrictBool] = None
    max_allowed_memberships: Optional[StrictInt] = None
    admin_delete_enabled: Optional[StrictBool] = None
    domains_enabled: Optional[StrictBool] = None
    domains_enrollment_modes: Optional[List[StrictStr]] = Field(default=None, description="Specify which enrollment modes to enable for your Organization Domains. Supported modes are 'automatic_invitation' & 'automatic_suggestion'.")
    creator_role_id: Optional[StrictStr] = Field(default=None, description="Specify what the default organization role is for an organization creator.")
    domains_default_role_id: Optional[StrictStr] = Field(default=None, description="Specify what the default organization role is for the organization domains.")
    __properties: ClassVar[List[str]] = ["enabled", "max_allowed_memberships", "admin_delete_enabled", "domains_enabled", "domains_enrollment_modes", "creator_role_id", "domains_default_role_id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateInstanceOrganizationSettingsRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if enabled (nullable) is None
        # and model_fields_set contains the field
        if self.enabled is None and "enabled" in self.model_fields_set:
            _dict['enabled'] = None

        # set to None if max_allowed_memberships (nullable) is None
        # and model_fields_set contains the field
        if self.max_allowed_memberships is None and "max_allowed_memberships" in self.model_fields_set:
            _dict['max_allowed_memberships'] = None

        # set to None if admin_delete_enabled (nullable) is None
        # and model_fields_set contains the field
        if self.admin_delete_enabled is None and "admin_delete_enabled" in self.model_fields_set:
            _dict['admin_delete_enabled'] = None

        # set to None if domains_enabled (nullable) is None
        # and model_fields_set contains the field
        if self.domains_enabled is None and "domains_enabled" in self.model_fields_set:
            _dict['domains_enabled'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateInstanceOrganizationSettingsRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "enabled": obj.get("enabled"),
            "max_allowed_memberships": obj.get("max_allowed_memberships"),
            "admin_delete_enabled": obj.get("admin_delete_enabled"),
            "domains_enabled": obj.get("domains_enabled"),
            "domains_enrollment_modes": obj.get("domains_enrollment_modes"),
            "creator_role_id": obj.get("creator_role_id"),
            "domains_default_role_id": obj.get("domains_default_role_id")
        })
        return _obj


